using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;

using Microsoft.Xna.Framework;

using Syntriax.Engine.Core.Abstract;

namespace Syntriax.Engine.Physics2D.Abstract;

public interface ICollider2D : IBehaviour, IAssignableTransform
{
    IRigidBody2D? RigidBody2D { get; }

    Action<ICollider2D, ICollider2D>? OnCollisionPreResolve { get; set; }

    bool CheckCollision(Vector2 point, ICollider2D otherCollider);
    void Recalculate();
}
